#include "LAMPWBDDManager.h"
#include <QJsonArray>
#include <QString>
#include <QNetworkAccessManager>
#include <QNetworkRequest>
#include <qjsonobject.h>
#include <QJsonDocument>
#include <qobject.h>
#include <QUrl>
#include <QUrlQuery>
#include "TaskOrder.h"

namespace LAMPWBCONNECT {
	LAMPWBDDManager::LAMPWBDDManager()
	{
	}
	LAMPWBDDManager::~LAMPWBDDManager()
	{
	}
	void LAMPWBDDManager::loginIn()
	{


	}
	void LAMPWBDDManager::getTaskList(int count, int pagenum)
	{
		QNetworkAccessManager* manager = new QNetworkAccessManager();
		QUrl url = QUrl(QString( "https://124.16.188.131:9699/gateway/api/interface/ddtc/dealManage/wbfzddSearch?"));
		qDebug() << QString("count : %1 , pagenum: %2 , orderType: %3").arg(count).arg(pagenum).arg(QString(u8"΢涩"));
		QUrlQuery query;
		query.addQueryItem("count", QString::number(count));
		query.addQueryItem("pagenum", QString::number(pagenum));
		query.addQueryItem("orderType", QString(u8"΢涩"));
		url.setQuery(query);
		
		QNetworkRequest request;
		request.setUrl(url);
		request.setHeader(QNetworkRequest::ContentTypeHeader, "application/json");
		//request.setHeader(QNetworkRequest::ContentTypeHeader, "application/x-www-form-urlencoded");
		QSslConfiguration config = QSslConfiguration::defaultConfiguration();
		config.setProtocol(QSsl::AnyProtocol);;
		config.setPeerVerifyMode(QSslSocket::VerifyNone);
		request.setSslConfiguration(config);

		QByteArray postData;// = query.toString().toUtf8();
		QNetworkReply* reply = manager->post(request, postData);

		QObject::connect(reply, &QNetworkReply::finished, [reply, manager]() {
			if (reply->error() == QNetworkReply::NoError) {
				QByteArray response_data = reply->readAll();
				QJsonDocument doc = QJsonDocument::fromJson(response_data); 
				//qDebug() << response_data;
				qDebug() << doc["total"] ;
				qDebug() << doc["pagenum"] ;

				WBFZTASK::TaskCollect::getInstance()->LoadTaskCollect(doc, reply->errorString());
				qDebug() << "request success " << reply->url();
			}
			else {
				WBFZTASK::TaskCollect::getInstance()->LoadTaskCollectState(reply->errorString());
				qDebug() << "request failed:" << reply->errorString();
			}
			reply->deleteLater();
			});
	}
	void LAMPWBDDManager::updateTaskoderStatus(QString taskid, QString taskstatus)
	{
		QNetworkAccessManager* manager = new QNetworkAccessManager();
		QUrl url = QUrl(QString("https://caplos.aircas.ac.cn/gateway/api/interface/ddtc/managedeal/wbfzdd/statusupdate"));
 		QJsonObject jsonObj;
		jsonObj["orderid"] = taskid;
		jsonObj["orderstatus"] = taskstatus;
		QJsonDocument jsonDoc(jsonObj);
		QByteArray postData = jsonDoc.toJson(); // תΪJSONֽ

		QNetworkRequest request;
		request.setUrl(url);
		request.setHeader(QNetworkRequest::ContentTypeHeader, "application/json");
		//request.setHeader(QNetworkRequest::ContentTypeHeader, "application/x-www-form-urlencoded");
		QSslConfiguration config = QSslConfiguration::defaultConfiguration();
		config.setProtocol(QSsl::AnyProtocol);;
		config.setPeerVerifyMode(QSslSocket::VerifyNone);
		request.setSslConfiguration(config);


 		QNetworkReply* reply = manager->post(request, postData);

		QObject::connect(reply, &QNetworkReply::finished, [reply, manager]() {
			if (reply->error() == QNetworkReply::NoError) {
				QByteArray response_data = reply->readAll();
				QJsonDocument doc = QJsonDocument::fromJson(response_data);
				//qDebug() << response_data;
				qDebug() << doc["msg"];
				qDebug() << doc["code"];

				//WBFZTASK::TaskCollect::getInstance()->LoadTaskCollect(doc, reply->errorString());
				qDebug() << "request success " << reply->url();
			}
			else {
				//WBFZTASK::TaskCollect::getInstance()->LoadTaskCollectState(reply->errorString());
				qDebug() << "request failed:" << reply->errorString();
			}
			reply->deleteLater();
			});
	}
}

