#include "TaskOrder.h"
#include <qstring.h>
#include <QJsonDocument>
#include <qjsonobject.h>
#include <qdebug.h>
#include <qjsonarray.h>
namespace WBFZTASK {

    TaskCollect* TaskCollect::instance = nullptr;


    TaskOrder::TaskOrder(){}

    TaskOrder::TaskOrder(const QJsonObject& jsonObj) {
        // ʹQJsonObjectʼгԱ
        createTime = jsonObj["createtime"].toString();
        orderStatus = jsonObj["orderstatus"].toString();
        orderId = jsonObj["orderid"].toString();
        orderMode = jsonObj["ordermode"].toString();
        ip = jsonObj["ip"].toString();
        orderDownloadAddr = jsonObj["orderdownloadaddr"].toString();
        userId = jsonObj["userid"].toString();
        demand = jsonObj["demand"].toString();
        orderSource = jsonObj["ordersource"].toString();
        applicant = jsonObj["applicant"].toString();
        intention = jsonObj["intention"].toString();
        orderStoreProcess = jsonObj["orderstoreprocess"].toString();
        orderCode = jsonObj["ordercode"].toString();
        qrstCode = jsonObj["qrstcode"].toString();
        contactInfo = jsonObj["contactinfo"].toString();
        orderDetails = jsonObj["orderdetails"].toString();
        company = jsonObj["company"].toString();
        dataSize = jsonObj["datasize"].toString();
        updateTime = jsonObj["updatetime"].toString();
        orderType = jsonObj["ordertype"].toString();

        //// ӡ

        //for (auto key : jsonObj.keys()) {
        //    QJsonValue value = jsonObj.value(key);

        //    // ֵǷΪ null
        //    if (value.isNull()) {
        //        qDebug() << key << ": null";
        //    }
        //    else {
        //        qDebug() << key << ":" << value.toVariant().toString();
        //    }
        //}



        //qDebug() << "createTime 		  " << createTime;
        //qDebug() << "orderStatus 		  " << orderStatus;
        //qDebug() << "orderId 			  " << orderId;
        //qDebug() << "orderMode 		  " << orderMode;
        //qDebug() << "ip 				  " << ip;
        //qDebug() << "orderDownloadAddr  " << orderDownloadAddr;
        //qDebug() << "userId 			  " << userId;
        //qDebug() << "demand 			  " << demand;
        //qDebug() << "orderSource 		  " << orderSource;
        //qDebug() << "applicant 		  " << applicant;
        //qDebug() << "intention 		  " << intention;
        //qDebug() << "orderStoreProcess  " << orderStoreProcess;
        //qDebug() << "orderCode 		  " << orderCode;
        //qDebug() << "qrstCode 		  " << qrstCode;
        //qDebug() << "contactInfo 		  " << contactInfo;
        //qDebug() << "orderDetails 	  " << orderDetails;
        //qDebug() << "company 			  " << company;
        //qDebug() << "dataSize 		  " << dataSize;
        //qDebug() << "updateTime 		  " << updateTime;
        //qDebug() << "orderType 		  " << orderType;

    }

    void TaskOrder::setCreateTime(const QString& value) { createTime = value; }
    QString TaskOrder::getCreateTime() const { return createTime; }

    void TaskOrder::setOrderStatus(const QString& value) { orderStatus = value; }
    QString TaskOrder::getOrderStatus() const { return  orderStatus; }

    void TaskOrder::setOrderId(QString value) { orderId = value; }
    QString TaskOrder::getOrderId() const { return  orderId; }

    void TaskOrder::setOrderMode(const QString& value) { orderMode = value; }
    QString TaskOrder::getOrderMode() const { return orderMode; }

    void TaskOrder::setIp(const QString& value) { ip = value; }
    QString TaskOrder::getIp() const { return ip; }

    void TaskOrder::setOrderDownloadAddr(const QString& value) { orderDownloadAddr = value; }
    QString TaskOrder::getOrderDownloadAddr() const { return  orderDownloadAddr; }

    void TaskOrder::setUserId(const QString& value) { userId = value; }
    QString TaskOrder::getUserId() const { return userId; }

    void TaskOrder::setDemand(const QString& value) { demand = value; }
    QString TaskOrder::getDemand() const { return demand; }

    void TaskOrder::setOrderSource(const QString& value) { orderSource = value; }
    QString TaskOrder::getOrderSource() const { return  orderSource; }

    void TaskOrder::setApplicant(const QString& value) { applicant = value; }
    QString TaskOrder::getApplicant() const { return applicant; }

    void TaskOrder::setIntention(const QString& value) { intention = value; }
    QString TaskOrder::getIntention() const { return intention; }

    void TaskOrder::setOrderStoreProcess(const QString& value) { orderStoreProcess = value; }
    QString TaskOrder::getOrderStoreProcess() const { return  orderStoreProcess; }

    void TaskOrder::setOrderCode(const QString& value) { orderCode = value; }
    QString TaskOrder::getOrderCode() const { return  orderCode; }

    void TaskOrder::setQrstCode(const QString& value) { qrstCode = value; }
    QString TaskOrder::getQrstCode() const { return qrstCode; }

    void TaskOrder::setContactInfo(const QString& value) { contactInfo = value; }
    QString TaskOrder::getContactInfo() const { return contactInfo; }

    void TaskOrder::setOrderDetails(const QString& value) { orderDetails = value; }
    QString TaskOrder::getOrderDetails() const { return  orderDetails; }

    void TaskOrder::setCompany(const QString& value) { company = value; }
    QString TaskOrder::getCompany() const { return company; }

    void TaskOrder::setDataSize(const QString& value) { dataSize = value; }
    QString TaskOrder::getDataSize() const { return dataSize; }

    void TaskOrder::setUpdateTime(const QString& value) { updateTime = value; }
    QString TaskOrder::getUpdateTime() const { return updateTime; }

    void TaskOrder::setOrderType(const QString& value) { orderType = value; }
    QString TaskOrder::getOrderType() const { return  orderType; }

    void TaskCollect::LoadTaskCollect(QJsonDocument& doc, QString message)
    {

        this->Currnettasklist.clear();

        if (doc["msg"].toString().contains("SUCCESS")) {
            qDebug() << "state SUCCESS";
            this->state = WBTASKSAPIREQURSTSTATE::SUCCESS;

            this->total = doc["total"].toInt();
            this->pagenum = doc["pagenum"].toInt();
           
            QJsonValue data = doc["data"];
            if (data.isArray()) {
                
                QJsonArray datalist = data.toArray();

                for (size_t i = 0; i < datalist.count(); i++) {
                    QJsonObject jsonObj = datalist.at(i).toObject();

                    if (jsonObj.contains("ordertype") && !(jsonObj["ordertype"].isNull()) && (jsonObj["ordertype"].toString().contains(QString(u8"΢涩"))))
                    {
                        TaskOrder neworder(jsonObj);
                        this->Currnettasklist.append(neworder);
                    }
                    else {
                        //qDebug() << jsonObj.contains("ordertype") <<" "<< !(jsonObj["ordertype"].isNull()) <<"  "<<(jsonObj["ordertype"].toString().contains(QString(u8"΢涩")))<<" "<< jsonObj["ordertype"].toString();
                        //TaskOrder neworder(jsonObj);
                        //this->Currnettasklist.append(neworder);
                    }
                }
                this->pagecount = this->Currnettasklist.count();
                qDebug() << "load data array  , count " << this->pagecount;
            }
            else {
                this->pagecount = 0;
            }

        }
        else {
            qDebug() << "state not  SUCCESS";
            this->state = WBTASKSAPIREQURSTSTATE::FAIL;
            this->total = 0;
            this->pagenum = 0;
            this->pagecount = 0;
        }
        this->pagecount = this->Currnettasklist.count();
        emit this->updateSIG(this->state,message);
    }

    void TaskCollect::LoadTaskCollectState(QString message)
    {
        this->clear();
        this->state= WBTASKSAPIREQURSTSTATE::ERROR;
        emit this->updateSIG(this->state, message);
    }

    TaskCollect* TaskCollect::getInstance()
    {

        if (nullptr == TaskCollect::instance) {
            TaskCollect::instance = new TaskCollect; 
        }
        else {}
        return TaskCollect::instance;
    }

    int TaskCollect::clear()
    {
        this->state = WBTASKSAPIREQURSTSTATE::FAIL;
        this->total = 0;
        this->pagenum = 0;
        this->pagecount = 0;
        return 0;
    }

    int TaskCollect::getPagenum()
    {
        return this->pagenum;
    }

    int TaskCollect::getTotal()
    {
        return this->total;
    }

    int TaskCollect::getPagecount()
    {
        return this->pagecount;
    }

    TaskOrder* TaskCollect::getCurrentTaskAt(int i)
    {
        return &this->Currnettasklist[i];
    }

    TaskCollect::TaskCollect() {
        this->state = WBTASKSAPIREQURSTSTATE::FAIL;
        this->total = 0;
        this->pagenum = 0;
        this->pagecount = 0;
    }
}